unit JRBOA_Consts;

interface

uses
  Winapi.Windows;

const
  x86StateID = '{F8954142-4587-421E-9519-CE85C98EE0F6}';
  x64StateID = '{F698CC53-C3FF-4BD8-AEC8-A9B9FFFE7D9A}';

function IsRunning(StateID: string): Boolean;

implementation

function IsRunning(StateID: string): Boolean;
var
  Mutex: THandle;
begin
  Mutex := OpenMutex(MUTEX_ALL_ACCESS, False, PChar(StateID));
  Result := Mutex <> 0;
  CloseHandle(Mutex);
end;

end.
