unit JRBOA_Escort;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs;

type
  TEscortForm = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private 錾 }
    procedure AssistStart;
    procedure AssistStop;
  public
    { Public 錾 }
  end;

var
  EscortForm: TEscortForm;

implementation

{$R *.dfm}

type
  //Jerboa.x64.dll ֐
  TInstallHook = function: Boolean; stdcall;
  TUninstallHook = procedure; stdcall;

var
  LibHandle: THandle;
  InstallHook: TInstallHook;
  UninstallHook: TUninstallHook;

procedure TEscortForm.AssistStart;
begin
  //tbNJn
  LibHandle := LoadLibrary(PChar(ChangeFileExt(ParamStr(0), '.dll')));
  if LibHandle > 0 then
  begin
    @InstallHook := GetProcAddress(LibHandle, 'InstallHook');
    if not Assigned(@InstallHook) then
      raise Exception.Create(SysErrorMessage(GetLastError));
    @UninstallHook := GetProcAddress(LibHandle, 'UninstallHook');
    if not Assigned(@UninstallHook) then
      raise Exception.Create(SysErrorMessage(GetLastError));

    if not InstallHook then
      raise Exception.Create(SysErrorMessage(GetLastError));

    {$IFDEF DEBUG}
    OutputDebugString('JRBOA: START - Jerboa.x64.dll');
    {$ENDIF DEBUG}
  end
  else
    raise Exception.Create(SysErrorMessage(GetLastError));
end;

procedure TEscortForm.AssistStop;
begin
  if LibHandle > 0 then
  begin
    UninstallHook;
    FreeLibrary(LibHandle);
    LibHandle := 0;

    {$IFDEF DEBUG}
    OutputDebugString('JRBOA: STOP - Jerboa.x64.dll');
    {$ENDIF DEBUG}
  end;
end;

procedure TEscortForm.FormCreate(Sender: TObject);
begin
  Application.ShowMainForm := False;

  AssistStart;
end;

procedure TEscortForm.FormDestroy(Sender: TObject);
begin
  AssistStop;
end;

end.
